Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/doc/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/doc/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/doc/Makefile	(revision 88)
@@ -0,0 +1,19 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ include ]------------------------------------------
+
+all				:
+				$(MAKE) all_documentation
+
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Documentation
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/OOO_Engine_Glue.h	(revision 88)
@@ -0,0 +1,256 @@
+#ifndef morpheo_behavioural_core_multi_ooo_engine_ooo_engine_ooo_engine_glue_OOO_Engine_Glue_h
+#define morpheo_behavioural_core_multi_ooo_engine_ooo_engine_ooo_engine_glue_OOO_Engine_Glue_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Parameters.h"
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Types.h"
+#ifdef STATISTICS
+#include "Behavioural/include/Stat.h"
+#endif
+#include "Behavioural/include/Component.h"
+#ifdef VHDL
+#include "Behavioural/include/Vhdl.h"
+#endif
+#include "Behavioural/include/Usage.h"
+
+#include "Common/include/ToString.h"
+#include "Common/include/Debug.h"
+
+#include <iostream>
+
+namespace morpheo {
+namespace behavioural {
+
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+  class OOO_Engine_Glue 
+#if SYSTEMC
+    : public sc_module
+#endif
+  {
+    // -----[ fields ]----------------------------------------------------
+    // Parameters
+  protected : const std::string  _name;
+  protected : const Parameters * _param;
+  private   : const Tusage_t     _usage;
+
+#ifdef STATISTICS
+  public    : Stat                           * _stat;
+#endif
+
+  public    : Component                      * _component;
+  private   : Interfaces                     * _interfaces;
+
+#ifdef SYSTEMC
+    // ~~~~~[ Interface ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_CLOCK                      *  in_CLOCK        ;
+  public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
+
+    // ~~~~~[ Interface : "rename" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontext_t         ) ***  in_RENAME_FRONT_END_ID                          ;//[nb_front_end][nb_inst_decod]
+  public    : SC_OUT(Tcontext_t         ) *** out_RENAME_RENAME_UNIT_FRONT_END_ID              ;//[nb_front_end][nb_inst_decod]
+
+    // ~~~~~[ Interface : "insert" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t         )  ** out_INSERT_VAL                                   ;//[sum_inst_insert]
+  public    : SC_IN (Tcontrol_t         )  **  in_INSERT_ACK                                   ;//[sum_inst_insert]
+  public    : SC_OUT(Tcontrol_t         )  ** out_INSERT_RD_USE                                ;//[sum_inst_insert]
+  public    : SC_OUT(Tgeneral_address_t )  ** out_INSERT_RD_NUM_REG                            ;//[sum_inst_insert]
+  public    : SC_OUT(Tcontrol_t         )  ** out_INSERT_RE_USE                                ;//[sum_inst_insert]
+  public    : SC_OUT(Tspecial_address_t )  ** out_INSERT_RE_NUM_REG                            ;//[sum_inst_insert]
+
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_RENAME_UNIT_VAL                       ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_RENAME_UNIT_ACK                       ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_RENAME_UNIT_NO_EXECUTE                ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontext_t         ) ***  in_INSERT_RENAME_UNIT_FRONT_END_ID              ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontext_t         ) ***  in_INSERT_RENAME_UNIT_CONTEXT_ID                ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Ttype_t            ) ***  in_INSERT_RENAME_UNIT_TYPE                      ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Toperation_t       ) ***  in_INSERT_RENAME_UNIT_OPERATION                 ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_RENAME_UNIT_HAS_IMMEDIAT              ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tgeneral_data_t    ) ***  in_INSERT_RENAME_UNIT_IMMEDIAT                  ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tlsq_ptr_t         ) ***  in_INSERT_RENAME_UNIT_STORE_QUEUE_PTR_WRITE     ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tlsq_ptr_t         ) ***  in_INSERT_RENAME_UNIT_LOAD_QUEUE_PTR_WRITE      ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_RENAME_UNIT_READ_RA                   ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tgeneral_address_t ) ***  in_INSERT_RENAME_UNIT_NUM_REG_RA_PHY            ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_RENAME_UNIT_READ_RB                   ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tgeneral_address_t ) ***  in_INSERT_RENAME_UNIT_NUM_REG_RB_PHY            ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_RENAME_UNIT_READ_RC                   ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tspecial_address_t ) ***  in_INSERT_RENAME_UNIT_NUM_REG_RC_PHY            ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_RENAME_UNIT_WRITE_RD                  ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tgeneral_address_t ) ***  in_INSERT_RENAME_UNIT_NUM_REG_RD_PHY_OLD        ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tgeneral_address_t ) ***  in_INSERT_RENAME_UNIT_NUM_REG_RD_PHY_NEW        ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_RENAME_UNIT_WRITE_RE                  ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tspecial_address_t ) ***  in_INSERT_RENAME_UNIT_NUM_REG_RE_PHY_OLD        ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tspecial_address_t ) ***  in_INSERT_RENAME_UNIT_NUM_REG_RE_PHY_NEW        ;//[nb_rename_unit][nb_inst_insert]
+
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_COMMIT_UNIT_VAL                       ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_COMMIT_UNIT_ACK                       ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontext_t         ) *** out_INSERT_COMMIT_UNIT_FRONT_END_ID              ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontext_t         ) *** out_INSERT_COMMIT_UNIT_CONTEXT_ID                ;//[nb_rename_unit][nb_inst_insert]
+//public    : SC_OUT(Tcontext_t         ) *** out_INSERT_COMMIT_UNIT_RENAME_UNIT_ID            ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Ttype_t            ) *** out_INSERT_COMMIT_UNIT_TYPE                      ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Toperation_t       ) *** out_INSERT_COMMIT_UNIT_OPERATION                 ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_COMMIT_UNIT_NO_EXECUTE                ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tlsq_ptr_t         ) *** out_INSERT_COMMIT_UNIT_STORE_QUEUE_PTR_WRITE     ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tlsq_ptr_t         ) *** out_INSERT_COMMIT_UNIT_LOAD_QUEUE_PTR_WRITE      ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_COMMIT_UNIT_READ_RA                   ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tgeneral_address_t ) *** out_INSERT_COMMIT_UNIT_NUM_REG_RA_PHY            ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_COMMIT_UNIT_READ_RB                   ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tgeneral_address_t ) *** out_INSERT_COMMIT_UNIT_NUM_REG_RB_PHY            ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_COMMIT_UNIT_READ_RC                   ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tspecial_address_t ) *** out_INSERT_COMMIT_UNIT_NUM_REG_RC_PHY            ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_COMMIT_UNIT_WRITE_RD                  ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tgeneral_address_t ) *** out_INSERT_COMMIT_UNIT_NUM_REG_RD_PHY_OLD        ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tgeneral_address_t ) *** out_INSERT_COMMIT_UNIT_NUM_REG_RD_PHY_NEW        ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_COMMIT_UNIT_WRITE_RE                  ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tspecial_address_t ) *** out_INSERT_COMMIT_UNIT_NUM_REG_RE_PHY_OLD        ;//[nb_rename_unit][nb_inst_insert]
+  public    : SC_OUT(Tspecial_address_t ) *** out_INSERT_COMMIT_UNIT_NUM_REG_RE_PHY_NEW        ;//[nb_rename_unit][nb_inst_insert]
+
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_ISSUE_QUEUE_VAL                       ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_IN (Tcontrol_t         ) ***  in_INSERT_ISSUE_QUEUE_ACK                       ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tcontext_t         ) *** out_INSERT_ISSUE_QUEUE_CONTEXT_ID                ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tcontext_t         ) *** out_INSERT_ISSUE_QUEUE_FRONT_END_ID              ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Toperation_t       ) *** out_INSERT_ISSUE_QUEUE_OPERATION                 ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Ttype_t            ) *** out_INSERT_ISSUE_QUEUE_TYPE                      ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tlsq_ptr_t         ) *** out_INSERT_ISSUE_QUEUE_STORE_QUEUE_PTR_WRITE     ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tlsq_ptr_t         ) *** out_INSERT_ISSUE_QUEUE_LOAD_QUEUE_PTR_WRITE      ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_ISSUE_QUEUE_HAS_IMMEDIAT              ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tgeneral_data_t    ) *** out_INSERT_ISSUE_QUEUE_IMMEDIAT                  ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_ISSUE_QUEUE_READ_RA                   ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tgeneral_address_t ) *** out_INSERT_ISSUE_QUEUE_NUM_REG_RA                ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_ISSUE_QUEUE_READ_RB                   ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tgeneral_address_t ) *** out_INSERT_ISSUE_QUEUE_NUM_REG_RB                ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_ISSUE_QUEUE_READ_RC                   ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tspecial_address_t ) *** out_INSERT_ISSUE_QUEUE_NUM_REG_RC                ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_ISSUE_QUEUE_WRITE_RD                  ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tgeneral_address_t ) *** out_INSERT_ISSUE_QUEUE_NUM_REG_RD                ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tcontrol_t         ) *** out_INSERT_ISSUE_QUEUE_WRITE_RE                  ;//[nb_rename_unit][nb_inst_rename]
+  public    : SC_OUT(Tspecial_address_t ) *** out_INSERT_ISSUE_QUEUE_NUM_REG_RE                ;//[nb_rename_unit][nb_inst_rename]
+
+//     // ~~~~~[ Interface "retire" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+//   public    : SC_OUT(Tcontrol_t         )  ** out_RETIRE_VAL                                   ;//[sum_inst_retire]
+//   public    : SC_IN (Tcontrol_t         )  **  in_RETIRE_ACK                                   ;//[sum_inst_retire]
+//   public    : SC_OUT(Tcontrol_t         )  ** out_RETIRE_RD_OLD_USE                            ;//[sum_inst_retire] 
+//   public    : SC_OUT(Tgeneral_address_t )  ** out_RETIRE_RD_OLD_NUM_REG                        ;//[sum_inst_retire]
+//   public    : SC_OUT(Tcontrol_t         )  ** out_RETIRE_RD_NEW_USE                            ;//[sum_inst_retire]
+//   public    : SC_OUT(Tgeneral_address_t )  ** out_RETIRE_RD_NEW_NUM_REG                        ;//[sum_inst_retire]
+//   public    : SC_OUT(Tcontrol_t         )  ** out_RETIRE_RE_OLD_USE                            ;//[sum_inst_retire] 
+//   public    : SC_OUT(Tspecial_address_t )  ** out_RETIRE_RE_OLD_NUM_REG                        ;//[sum_inst_retire]
+//   public    : SC_OUT(Tcontrol_t         )  ** out_RETIRE_RE_NEW_USE                            ;//[sum_inst_retire]
+//   public    : SC_OUT(Tspecial_address_t )  ** out_RETIRE_RE_NEW_NUM_REG                        ;//[sum_inst_retire]
+
+//   public    : SC_OUT(Tcontrol_t         ) *** out_RETIRE_RENAME_UNIT_VAL                       ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tcontrol_t         ) ***  in_RETIRE_RENAME_UNIT_ACK                       ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tcontext_t         ) *** out_RETIRE_RENAME_UNIT_FRONT_END_ID              ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tcontrol_t         ) *** out_RETIRE_RENAME_UNIT_WRITE_RD                  ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tgeneral_address_t ) *** out_RETIRE_RENAME_UNIT_NUM_REG_RD_PHY_OLD        ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tgeneral_address_t ) *** out_RETIRE_RENAME_UNIT_NUM_REG_RD_PHY_NEW        ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tcontrol_t         ) *** out_RETIRE_RENAME_UNIT_WRITE_RE                  ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tspecial_address_t ) *** out_RETIRE_RENAME_UNIT_NUM_REG_RE_PHY_OLD        ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tspecial_address_t ) *** out_RETIRE_RENAME_UNIT_NUM_REG_RE_PHY_NEW        ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tevent_state_t     ) *** out_RETIRE_RENAME_UNIT_EVENT_STATE               ;//[nb_rename_unit][nb_inst_retire]
+
+//   public    : SC_IN (Tcontrol_t         ) ***  in_RETIRE_COMMIT_UNIT_VAL                       ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_OUT(Tcontrol_t         ) *** out_RETIRE_COMMIT_UNIT_ACK                       ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tcontext_t         ) ***  in_RETIRE_COMMIT_UNIT_FRONT_END_ID              ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tcontrol_t         ) ***  in_RETIRE_COMMIT_UNIT_WRITE_RD                  ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tgeneral_address_t ) ***  in_RETIRE_COMMIT_UNIT_NUM_REG_RD_PHY_OLD        ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tgeneral_address_t ) ***  in_RETIRE_COMMIT_UNIT_NUM_REG_RD_PHY_NEW        ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tcontrol_t         ) ***  in_RETIRE_COMMIT_UNIT_WRITE_RE                  ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tspecial_address_t ) ***  in_RETIRE_COMMIT_UNIT_NUM_REG_RE_PHY_OLD        ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tspecial_address_t ) ***  in_RETIRE_COMMIT_UNIT_NUM_REG_RE_PHY_NEW        ;//[nb_rename_unit][nb_inst_retire]
+//   public    : SC_IN (Tevent_state_t     ) ***  in_RETIRE_COMMIT_UNIT_EVENT_STATE               ;//[nb_rename_unit][nb_inst_retire]
+
+    // ~~~~~[ Interface : "spr" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t         ) *** out_SPR_SR_IEE                                   ;//[nb_front_end][nb_context] - Interrupt Exception Enabled
+  public    : SC_OUT(Tcontrol_t         ) *** out_SPR_SR_EPH                                   ;//[nb_front_end][nb_context] - Exception Prefix High
+  public    : SC_OUT(Tspr_t             ) *** out_SPR_RENAME_UNIT_SR                           ;//[nb_front_end][nb_context]
+  public    : SC_OUT(Tcontrol_t         ) *** out_SPR_COMMIT_UNIT_SR_OVE                       ;//[nb_front_end][nb_context]
+  public    : SC_IN (Tspr_t             ) ***  in_SPR_SPECIAL_REGISTER_UNIT_SR                 ;//[nb_front_end][nb_context]
+
+    // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
+
+    // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#endif
+
+    // -----[ Methods ]---------------------------------------------------
+
+#ifdef SYSTEMC
+    SC_HAS_PROCESS (OOO_Engine_Glue);
+#endif
+  public  :          OOO_Engine_Glue              
+  (
+#ifdef SYSTEMC
+   sc_module_name                                name,
+#else					       
+   std::string                                   name,
+#endif					       
+#ifdef STATISTICS
+   morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+   Parameters                                  * param,
+   morpheo::behavioural::Tusage_t                usage
+   );
+  public  :          ~OOO_Engine_Glue             (void);
+					       
+  private : void        allocation                (
+#ifdef STATISTICS
+						   morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+						   void
+#endif
+						   );
+  private : void        deallocation              (void);
+					       
+#ifdef SYSTEMC				       
+  public  : void        transition                (void);
+//public  : void        genMoore                  (void);
+  public  : void        genMealy_rename           (void);
+  public  : void        genMealy_insert_valack    (void);
+  public  : void        genMealy_insert           (void);
+  public  : void        genMealy_retire_valack    (void);
+  public  : void        genMealy_retire           (void);
+  public  : void        genMealy_spr              (void);
+#endif					       
+
+#if VHDL				       
+  public  : void        vhdl                      (void);
+  private : void        vhdl_declaration          (Vhdl * & vhdl);
+  private : void        vhdl_body                 (Vhdl * & vhdl);
+#endif					       
+
+#ifdef STATISTICS
+  public  : void        statistics_allocation     (morpheo::behavioural::Parameters_Statistics * param_statistics);
+  public  : void        statistics_deallocation   (void);
+#endif
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void        end_cycle                 (void);
+#endif
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Parameters.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Parameters.h	(revision 88)
@@ -0,0 +1,100 @@
+#ifndef morpheo_behavioural_core_multi_ooo_engine_ooo_engine_ooo_engine_glue_Parameters_h
+#define morpheo_behavioural_core_multi_ooo_engine_ooo_engine_ooo_engine_glue_Parameters_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Types.h"
+#include "Behavioural/include/Parameters.h"
+#include "Common/include/Debug.h"
+#include <vector>
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+// #define translateFrontEndIdToRenameUnit(front_end_id)                   _param->_translate_front_end_id_to_rename_unit[front_end_id]
+// #define translateFrontEndIdFromRenameUnit(num_rename_unit,front_end_id) _param->_translate_front_end_id_from_rename_unit[num_rename_unit][front_end_id]
+
+  class Parameters : public morpheo::behavioural::Parameters
+  {
+    //-----[ fields ]------------------------------------------------------------
+  public : uint32_t                _nb_front_end                           ;
+  public : uint32_t              * _nb_context                             ;//[nb_front_end]
+  public : uint32_t                _nb_rename_unit                         ;
+  public : uint32_t              * _nb_inst_decod                          ;//[nb_front_end]
+  public : uint32_t              * _nb_inst_insert                         ;//[nb_rename_unit]
+  public : uint32_t              * _nb_inst_retire                         ;//[nb_rename_unit]
+//public : uint32_t                _size_general_data                      ;
+//public : uint32_t                _size_special_data                      ;
+  public : uint32_t              * _link_rename_unit_with_front_end        ;//[nb_front_end]
+  public : std::vector<uint32_t> * _translate_front_end_id_from_rename_unit;//[nb_rename_unit]
+//public : uint32_t                _size_packet_id                         ;
+//public : uint32_t                _size_general_register                  ;
+//public : uint32_t                _size_special_register                  ;
+//public : uint32_t                _size_store_queue_ptr                   ;
+//public : uint32_t                _size_load_queue_ptr                    ;
+                                                                           
+//public : uint32_t              * _rename_unit_nb_front_end               ;//[nb_rename_unit]
+//public : uint32_t             ** _rename_unit_nb_context                 ;//[nb_rename_unit][nb_front_end]
+//public : uint32_t              * _rename_unit_size_front_end_id          ;//[nb_rename_unit]
+//public : uint32_t              * _rename_unit_size_context_id            ;//[nb_rename_unit]
+//public : uint32_t                _size_front_end_id                      ;
+//public : uint32_t                _size_context_id                        ;
+  public : uint32_t                _size_rename_id                         ;
+  public : uint32_t                _sum_inst_insert                        ;
+//public : uint32_t                _sum_inst_retire                        ;
+  public : uint32_t              * _translate_front_end_id_to_rename_unit  ;//[nb_front_end]
+  public : Tgeneral_address_t      _mask_num_general_register              ;
+  public : Tspecial_address_t      _mask_num_special_register              ;
+
+//public : bool                    _have_port_front_end_id                 ;
+//public : bool                    _have_port_context_id                   ;
+//public : bool                    _have_port_packet_id                    ;
+//public : bool                    _have_port_load_queue_ptr               ;
+
+    //-----[ methods ]-----------------------------------------------------------
+  public : Parameters  (uint32_t                nb_front_end                           ,
+                        uint32_t              * nb_context                             ,
+                        uint32_t                nb_rename_unit                         ,
+                        uint32_t              * nb_inst_decod                          ,
+                        uint32_t              * nb_inst_insert                         ,
+                        uint32_t              * nb_inst_retire                         ,
+                        uint32_t                size_general_data                      ,
+                        uint32_t                size_special_data                      ,
+                        uint32_t              * link_rename_unit_with_front_end        ,
+                        std::vector<uint32_t> * translate_front_end_id_from_rename_unit,
+                        uint32_t                size_packet_id                         ,
+                        uint32_t                size_general_register                  ,
+                        uint32_t                size_special_register                  ,
+                        uint32_t                size_store_queue_ptr                   ,
+                        uint32_t                size_load_queue_ptr                    ,
+                        bool                    is_toplevel=false);
+//   public : Parameters  (Parameters & param) ;
+  public : ~Parameters () ;
+
+  public :        void            copy       (void);
+
+  public :        Parameters_test msg_error  (void);
+
+  public :        std::string     print      (uint32_t depth);
+  public : friend std::ostream&   operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::core::multi_ooo_engine::ooo_engine::ooo_engine_glue::Parameters & x);
+  };
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Types.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Types.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/OOO_Engine_Glue/include/Types.h	(revision 88)
@@ -0,0 +1,29 @@
+#ifndef morpheo_behavioural_core_multi_ooo_engine_ooo_engine_ooo_engine_glue_Types_h
+#define morpheo_behavioural_core_multi_ooo_engine_ooo_engine_ooo_engine_glue_Types_h
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Types.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+namespace ooo_engine_glue {
+
+
+}; // end namespace ooo_engine_glue
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+
+#endif
